/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2022  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.worldedit.mask.checkerboard3d;

import com.sk89q.worldedit.function.mask.Mask;
import com.sk89q.worldedit.math.BlockVector3;

public class Checkerboard3DMask implements Mask {

    private int x;
    private int y;
    private int z;

    public Checkerboard3DMask(int x, int y, int z) {
        this.x = x;
        this.y = y;
        this.z = z;
    }

    @Override
    public boolean test(BlockVector3 vector) {
        if (x == 0 && y == 0 && z == 0) return true;
        if (x == 0 && y == 0) return (vector.getBlockZ() / z) % 2 == 0;
        if (x == 0 && z == 0) return (vector.getBlockY() / y) % 2 == 0;
        if (y == 0 && z == 0) return (vector.getBlockX() / x) % 2 == 0;
        if (x == 0) return (vector.getBlockY() / y + vector.getBlockZ() / z) % 2 == 0;
        if (y == 0) return (vector.getBlockX() / x + vector.getBlockZ() / z) % 2 == 0;
        if (z == 0) return (vector.getBlockX() / x + vector.getBlockY() / y) % 2 == 0;
        return (vector.getBlockX() / x + vector.getBlockY() / y + vector.getBlockZ() / z) % 2 == 0;
    }

    @Override
    public Mask copy() {
        return new Checkerboard3DMask(x, y, z);
    }
}
